
#include <omp.h>
#include <stdio.h>
#include <limits.h>

#define N 12

int main (int argc, char *argv[]) {
  int a[N][N], i, j, min, max, sum;

  omp_set_num_threads(4);

  // initialize a
  for (i = 0; i < N; i++) {
    for (j = 0; j < N; j++) {
      a[i][j] = j % 2 ? i+j : -i-j;
    }
  }
  min = INT_MAX;
  max = INT_MIN;
  sum = 0;
  for (i = 0; i < N; i++) {
    for (j = 0; j < N; j++) {       
      if (a[i][j] < min) min = a[i][j];
      if (a[i][j] > max) max = a[i][j];
      sum += a[i][j];
    }
  }

  // Print a + min + max + sum
  printf("***********************************************************\n");
  for (int i = 0; i < N; i++) {
    for (int j = 0; j < N; j++) printf("%d ", a[i][j]);
    putchar('\n'); 
  }
  printf("***********************************************************\n");
  printf("Min: %d Max: %d Sum: %d\n", min, max, sum);
  return 0;
}

