
#include <omp.h>
#include <stdio.h>


#define N 12

int main(int argc, char** argv) {
  int a[N], b[N], c[N], i, x, y;
  
  omp_set_num_threads(4);

  for (i = 0; i < N; i++) {
    a[i] = i;
    b[i] = i;
    c[i] = i;
  }
  
  x = 123;

  // TODO: 
  // 1) identify and classify loop carried dependencies
  // 2) parallelize the loop.
  for (i = 1; i < N; i++) {
    x = x + a[i];
    y = a[i] + i;
    b[i] = b[i] + c[i - 1];
    c[i] = c[i] + y;
  }

  // print contents
  for (i = 0; i < N; i++) {
    printf("a[%d]=%d b[%d]=%d c[%d]=%d\n",
           i, a[i], i, b[i], i, c[i]);
  }
  printf("x = %d, y=%d\n", x, y);
  return 0;
}
