
#include <omp.h>
#include <stdio.h>


#define N 12
int main(int argc, char** argv) {
  int a[N], b[N], i, x;
  
  omp_set_num_threads(4);

  for (i = 0; i < N; i++) {
    a[i] = i;
    b[i] = i;
  }
  x = 123;  

  // TODO: 
  // 1) identify and classify dependencies
  // 2) parallelize the loop.
  for (i = 0; i < N - 1; i++) {
    x = x + a[i];
    b[i] = b[i] * x;
  }

  // print contents
  for (i = 0; i < N; i++) {
    printf("a[%d]=%d b[%d]=%d\n",
           i, a[i], i, b[i]);
  }
  printf("x = %d\n", x);
  return 0;

}
